# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import zipfile  
import os       

def update_package():
    # Initialisation
    package_updated = False
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()
    app_name = control.name

    download_dict = {
        "windows": "https://www.nirsoft.net/utils/folderchangesview.zip"
    }

    download_url = download_dict[control.target_os]
    latest_bin = download_url.rsplit('/', 1)[-1]
    latest_bin_extension = latest_bin.rsplit('.', 1)[-1]

    if not isfile(latest_bin):
        print(f"Downloading: {latest_bin}")
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print(f"Binary is present: {latest_bin}")

    # Décompression du fichier ZIP
    if latest_bin_extension == "zip":
        print(f"Extracting: {latest_bin}")
        with zipfile.ZipFile(latest_bin, 'r') as zip_ref:
            zip_ref.extractall()  # Extraction dans le répertoire courant

        # Recherche de l'exécutable .exe dans les fichiers extraits
        exe_file = None
        for file in os.listdir():  # Parcours uniquement dans le répertoire courant
            if file.endswith(".exe"):
                exe_file = file
                print(f"Found executable: {exe_file}")
                break
    else:
        print("Downloaded file is not a ZIP archive.")
    version = get_version_from_binary(exe_file)
    # Mise à jour de la version du package
    if Version(version) > Version(control.get_software_version()):
        print(f"Software version updated (from: {control.get_software_version()} to: {Version(version)})")
        package_updated = True
    else:
        print(f"Software version up-to-date ({Version(version)})")
    
    for f in glob.glob(f'*.{latest_bin_extension}'):
        if f != latest_bin:
            remove_file(f)

    control.set_software_version(version)
    control.save_control_to_wapt()

    return package_updated


